unit Unit1;

{
 project to find pythagorean triples
 (3,4,5)  (5,12,13) ..
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, dav7components;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    goBtn: TBitBtn;
    clearBtn: TBitBtn;
    proctimer: Tdav7Timer;
    timelabel: TStaticText;
    Label1: TLabel;
    triplescountlabel: TStaticText;
    Label2: TLabel;
    methodlabel: TLabel;
    Label4: TLabel;
    methodtext: TStaticText;
    procedure goBtnClick(Sender: TObject);
    procedure clearBtnClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure methodlabelMouseEnter(Sender: TObject);
    procedure methodlabelMouseLeave(Sender: TObject);
    procedure methodlabelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type TP3 = record
            a,b,c : word;
           end;

const
     mtext : array[1..3] of string = ('preset squares, no floating point',
                                      'floating point, simple search',
                                      'algebraic, no search');

var p3nr : byte;
    ptriples : array[1..200] of TP3;
    methodNr : byte;
    squares : array[1..1500] of dword;

procedure presetsquares;
var i : word;
begin
 for i := 1 to 1500 do squares[i] := i*i;
end;

procedure clear;
begin
 p3nr := 0;
 with form1 do
  begin
   Memo1.Clear;
   timelabel.caption := '';
   triplescountlabel.caption := '';
  end;
end;

function fixstring(w : word; n : byte) : string;
//w to string, expand string to n chars
var cc : shortInt;
    s,t : string;
    i : byte;
begin
 s := inttostr(w);
 cc := n - length(s);
 if cc > 0 then
  begin
   t := '';
   for i := 1 to cc do t := t + ' ';
   result := t+s;
  end else result := s;
end;

procedure initmemo;
var s : string;
begin
 with form1.Memo1 do
  begin
   Clear;
   s := '          a     b     c';
   lines.Add(s);
  end; 
end;

procedure report;
//triples to memo1
var w : word;
    s : string;
begin
 with form1 do
  begin
   triplescountlabel.Caption := inttostr(p3Nr);
   timelabel.Caption := inttostr(round(proctimer.ElapsedTime));
   for w := 1 to p3Nr do
    begin
     s := fixstring(w,4)+':';
     s := s + fixstring(ptriples[w].a,6);
     s := s + fixstring(ptriples[w].b,6);
     s := s + fixstring(ptriples[w].c,6);
     memo1.Lines.add(s);
    end;
   end;
end;

procedure sorttriples;
//a small --> large
//exchange sort
var i,j : byte;
    h : word;
    h3 : Tp3;
    swap :boolean;
begin
 for i := 1 to p3nr do     //sort a,b
  with ptriples[i] do
   if a > b then
    begin
     h := a;
     a := b;
     b := h;
    end;
 for i := 1 to p3nr-1 do  //sort [ ]
  for j := i+1 to p3nr do
   begin
    swap := (ptriples[i].a > ptriples[j].a) or
            ((ptriples[i].a = ptriples[j].a) and
             (ptriples[i].b > ptriples[j].b));
    if swap then
     begin
      h3 := ptriples[i];
      ptriples[i] := ptriples[j];
      ptriples[j] := h3;
     end;
   end;
end;

procedure addtriple(aa,bb,cc : word);
//add triple to array
begin
 inc(p3Nr);
 with ptriples[p3Nr] do
  begin
   a := aa;
   b := bb;
   c := cc;
  end;
end;

function GCD(a,b : word) : word; //greatest common devisor
var h : word;
begin
 repeat
  if a < b then
   begin
    h := a;
    a := b;
    b := h;
   end;
  a := a mod b;
 until a = 0;
 result := b;
end;

procedure p3method1;
//no floating point + preset squares
var a,b,c : word;
    c2 : dword;
    hit : boolean;
begin
 form1.proctimer.start;
 a := 0;
 repeat
  inc(a);
  b := a;
  repeat
   inc(b);
   if GCD(a,b) = 1 then
    begin
     c2 := squares[a] + squares[b];
     c := b;
     repeat
      inc(c);
      hit := squares[c] = c2;
     until hit or (squares[c] > c2);
     if hit then addtriple(a,b,c);
    end;
  until b = 999;
 until a = 998;
 form1.proctimer.stop;
end;

procedure p3method2;
//simple
var a,b : word;
    a2,b2 : dword;
    c : single;
begin
 form1.proctimer.start;
 for a := 1 to 998 do
  begin
   a2 := a*a;
   for b := a+1 to 999 do
    begin
     b2 := b*b;
     c := sqrt(a2 + b2);
     if frac(c) = 0 then
      if GCD(a,b) = 1 then addtriple(a,b,round(c));
    end;
  end;
 form1.proctimer.stop;
end;

procedure p3method3;
//algebraic
var a,b,x,y : word;
begin
 form1.proctimer.start;
 for x := 2 to 34 do
  begin
   for y := x-1 downto 1 do
    begin
     a := squares[x] -squares[y];
     if (a < 1000) then
      begin
       b := (x*y) shl 1;
       if (b < 1000) then
        if GCD(a,b) = 1 then addtriple(a,b,squares[x]+squares[y]);
      end;
    end;
  end;
 form1.proctimer.stop;
end;

procedure TForm1.goBtnClick(Sender: TObject);
begin
 clear;
 initmemo;
 application.processmessages;
 case methodNr of
  1 : p3method1;
  2 : p3method2;
  3 : begin
       p3method3;
       sorttriples;
      end;
 end;
 report;
end;

procedure paintBtnEdges(ct : Tcontrol; col : dword; w : byte);
//paint edges around control width = w
var x1,x2,y1,y2 : word;
    i : byte;
begin
 with ct do
  begin
   x1 := left-w;
   y1 := top-w;
   x2 := left+width+w-1;
   y2 := top+height+w-1;
 end;
 with form1.canvas do
  begin
   pen.color := col;
   for i := 1 to w do
    begin
     moveto(x1-i,y1-i);
     lineto(x1-i,y2+i);
     lineto(x2+i,y2+i);
     lineto(x2+i,y1-i);
     lineto(x1-i,y1-i);
    end;
  end;
end;

procedure TForm1.clearBtnClick(Sender: TObject);
begin
 Clear;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 paintBtnEdges(methodlabel,$000000,3);
 methodtext.caption := mtext[methodNr];
end;

procedure TForm1.methodlabelMouseEnter(Sender: TObject);
begin
 paintBtnEdges(methodlabel,$00c0ff,3);
end;

procedure TForm1.methodlabelMouseLeave(Sender: TObject);
begin
 paintBtnEdges(methodlabel,$000000,3);
end;

procedure TForm1.methodlabelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if button = mbLeft then
  begin
   if methodNr < 3 then inc(methodNr);
  end
  else if methodNr > 1 then dec(methodnr);
 methodlabel.Caption := inttostr(methodNr);
 methodtext.Caption := mtext[methodNr];
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 presetsquares;
 methodNr := 1;
 methodtext.Caption := mtext[methodNr];
end;

end.
